import gab.opencv.*;
import processing.serial.*;
import blobDetection.*;
import processing.core.*;
import org.opencv.imgproc.Imgproc;
import org.opencv.core.Mat;
import org.opencv.core.Size;
import java.util.Arrays;  //can be useful for debugging

int tx = 1;               //number of transmitter lines (tx)
int rx = 1;               //number of receiver lines (rx)
int serialPort = 0;       //serial port that the Arduino is connected to

int Height = 500;
int Width = 500;

int colorrange = 255; // colorrange of setColors (255 should be best), can be used to scale the input

/******* draw blobs, change to "true" when working on drawBlobsAndEdges() *******/
boolean drawBlobs = false; // false: will not draw blobs, true: will draw blobs

//variables needed to set the Baseline
boolean baseLineSet = false; // auxiliary variable, false while the Baseline is not set yet

//variables/objects for interpolation and blobdetection
OpenCV opencv; // openCV object for interpolation
BlobDetection theBlobDetection; // BlobDetection object for BlobDetection
PImage scaledbc; // image that results from interpolation and that will be drawn to the screen if  "autodraw" = true

void setup(){
  size(500, 500);
  background(255);
  
  // PSET4 TODO: Initialization

  //creating the font to draw on screen later
  PFont f;
  f = createFont("Arial",16,true); // Arial, 16 point, anti-aliasing on
  textFont(f,36); 
  
  // ************ PSet 5 ************
  // PSET5 TODO: 1. Create instance of class OneDollar
  
  // PSET5 TODO: 2. Add gestures (templates)
  
  // PSET5 TODO: 3. Bind templates to methods (callbacks):
  // you can also put each gesture into different callback function 
  // so that the UI can response to each gesture differently
  
}

// PSET5 TODO: 4. Implement callbacks (PSet 5)
//void detected(String gesture, float percent, int startX, int startY, int centroidX, int centroidY, int endX, int endY){
  
//}

void draw() {
  
  // PSET4 TODO: read the latest data from the SerialPort
  readSerial();

  // PSET4 TODO: set the Baseline 
  setBaseLine();
  
  // PSET4 TODO: substract the Baseline from raw values
  substractBaseLine();
  
  // PSET4 TODO: Set the background image color update
  setColors();

  // PSET4 TODO: Perform bicubic interpolation 
  interpolate();
  
  //if the baseline is not set yet, the sensor should not be touched, therefore "Calibrating!" will be printed on the screen to indicate this
  if(baseLineSet) {
    background(color(0,0,0));
    /******* Uncomment the following line when working on interpolate() *******/
    //image(scaledbc, 0, 0);
  }else {
    background(color(0,0,0));
    fill(255);
    text("Calibrating...",Width/3,Height/2);
  }

  // ************ PSet 5 ************
  // PSET5 TODO: Implement blob detection 
  if (drawBlobs) {
    // Leave the following function here
    // (imageForBlobDetection() will replace the edges of scaledbc with black pixels as workaround for a bug in BlobDetection)
    theBlobDetection.computeBlobs(imageForBlobDetection(scaledbc).pixels);
    // draw the blobs
    drawBlobsAndEdges(); 
  }

}

// PSET4 TODO: read the latest data from the SerialPort
public void readSerial() {  
  
}

// PSET4 TODO: set the Baseline 
public void setBaseLine() {
  
}

// PSET4 TODO: substract the Baseline from raw values 
public void substractBaseLine() {
  
}

/**
 * PSET4 TODO: rescales "img" to "scaledbc", using cubic interpolation
 */
public void interpolate() {
  
}

// ************ PSet 5 ************
/**
 * draw the Blob centers/edges to the screen look at the documentation of
 * BlobDetection for better understanding
 * (http://www.v3ga.net/processing/BlobDetection/index-page-documentation.html)
 */
public void drawBlobsAndEdges() {
  // PSET5 TODO: Implement blob detection
  
}

/**
 * PSET4 TODO: Set the background image color update
 * might scale up/down or adjust depending on your multi-touch circuit sensing values 
 * look at the processing method map() for better understanding of how the scaling works
 */
public void setColors() {
  
}

/*
 * this method will set the color of the pixels at the edge of the given picture to 0 (black)
 * this is so that BlobDetection will handle blobs near edges properly, so just a workaround for a bug in the BlobDetection library
 */
PImage imageForBlobDetection(PImage img) { 
  img.loadPixels();
  for(int i = 0; i < img.width; i++) {
    for(int j = 0; j < img.height; j++) {
      int p = i + j*(img.width);
      if(j == 0 || j == img.height-1 || i == 0 || i == img.width-1 ) {
        img.pixels[p] = color(0);
      }
    }
  }
  img.updatePixels();
  return img;
}
